---
title: XRRenderStateInit
slug: Web/API/XRRenderStateInit
tags:
  - API
  - AR
  - Dictionary
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRRenderStateInit
  - augmented
  - render
  - state
---
<p>{{APIRef("WebXR Device API")}}{{draft}}</p>

<p><span class="seoSummary">The <code><strong>XRRenderStateInit</strong></code> dictionary is a writeable version of the {{domxref("XRRenderState")}} interface, and is used when calling an {{domxref("XRSession")}}'s {{domxref("XRSession.updateRenderState", "updateRenderState()")}} method to apply changes to the render state prior to rendering the next frame.</span></p>

<p>All distances are specified as floating-point values in {{interwiki("wikipedia", "meter", "meters")}}; you can specify a value of 50 centimeters using a value of 0.5, for example.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>baseLayer</code> {{optional_inline}}</dt>
 <dd>An {{domxref("XRWebGLLayer")}} object from which the WebXR compositor will obtain imagery. This is <code>null</code> by default.</dd>
 <dt><code>depthFar</code> {{optional_inline}}</dt>
 <dd>A floating-point value specifying the distance in meters from the viewer to the <strong>far clip plane</strong>, which is a plane parallel to the display surface beyond which no further rendering will occur. All rendering will take place between the distances specified by <code>depthNear</code> and <code>depthFar</code>. This is 1000 meters (1 kilometer) by default.</dd>
 <dt><code>depthNear</code> {{optional_inline}}</dt>
 <dd>A floating-point value indicating the distance in meters from the viewer to a plane parallel to the display surface to be the <strong>near clip plane</strong>. No part of the scene on the viewer's side of this plane will be rendered. This is 0.1 meters (10 centimeters) by default.</dd>
 <dt><code>inlineVerticalFieldOfView</code> {{optional_inline}}</dt>
 <dd>A floating-point value indicating the default field of view, in radians, to be used when computing the projection matrix for an <code>inline</code> {{domxref("XRSession")}}. The projection matrix calculation also takes into account the output canvas's aspect ratio. This property <em>must not</em> be specified for immersive sessions, so the value is <code>null</code> by default for immersive sessions. The default value is otherwise π * 0.5 (half of the value of pi).</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>Any properties not specified in the <code>XRRenderStateInit</code> compliant object passed into {{domxref("XRSession.updateRenderState", "updateRenderState()")}} are left at their current values.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dictdef-xrrenderstateinit","XRRenderStateInit")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRRenderStateInit")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{domxref("XRRenderState")}}</li>
 <li>{{domxref("XRSession.renderState")}}</li>
 <li>{{domxref("XRSession.updateRenderState()")}}</li>
</ul>
